' Definiere den Typ fr die Titel:
TYPE TitelTyp
   HauptTitel AS STRING * 40
   XTitel AS STRING * 40
   YTitel AS STRING * 18
END TYPE
DECLARE SUB EingabTitel (T AS TitelTyp)
DECLARE FUNCTION Diagramm$ (T AS TitelTyp, bezeich$(), Wert!(), N%)
DECLARE FUNCTION EingabDaten% (bezeich$(), Wert!())
' Variablendeklarationen fr Titel und Balkendaten:
DIM Titel AS TitelTyp, bezeich$(1 TO 5), Wert(1 TO 5)
CONST FALSCH = 0, WAHR = NOT FALSCH
DO
   EingabTitel Titel
   N% = EingabDaten%(bezeich$(), Wert())
   IF N% <> FALSCH THEN
      NeuDiagr$ = Diagramm$(Titel, bezeich$(), Wert(), N%)
   END IF
LOOP WHILE NeuDiagr$ = "J"
END

'
' ==================== DIAGRAMM ======================
'   Zeichnet ein Balkendiagramm fr die in den
'   Prozeduren EINGABTITEL und EINGABDATEN
'   eingegebenen Daten.
' ====================================================
'
FUNCTION Diagramm$ (T AS TitelTyp, bezeich$(), Wert(), N%) STATIC
   ' Setze die Gre des Diagramms:
   CONST GRAPHOBEN = 24, GRAPHUNTEN = 171
   CONST GRAPHLINKS = 48, GRAPHRECHTS = 624
   CONST YLANG = GRAPHUNTEN - GRAPHOBEN
   ' Berechne maximalen und minimalen Wert:
   YMax = 0
   YMin = 0
   FOR I% = 1 TO N%
      IF Wert(I%) < YMin THEN YMin = Wert(I%)
      IF Wert(I%) > YMax THEN YMax = Wert(I%)
   NEXT I%
   ' Berechne Breite der Balken und Platz zwischen
   ' diesen:
   BalkBreit = (GRAPHRECHTS - GRAPHLINKS) / N%
   BalkZwisch = .2 * BalkBreit
   BalkBreit = BalkBreit - BalkZwisch
   SCREEN 2
   CLS
   ' Zeichne die y-Achse:
   LINE (GRAPHLINKS, GRAPHOBEN)-(GRAPHLINKS, GRAPHUNTEN), 1
   ' Zeichne Hauptberschrift des Diagramms:
   Start% = 44 - (LEN(RTRIM$(T.HauptTitel)) / 2)
   LOCATE 2, Start%
   PRINT RTRIM$(T.HauptTitel);
   ' Bezeichne y-Achse:
   Start% = CINT(13 - LEN(RTRIM$(T.YTitel)) / 2)
   FOR I% = 1 TO LEN(RTRIM$(T.YTitel))
      LOCATE Start% + I% - 1, 1
      PRINT MID$(T.YTitel, I%, 1);
   NEXT I%
   ' Berechne den Skalierungsfaktor, so da
   ' Bezeichnungen nicht grer als 4 Ziffern sind:
   IF ABS(YMax) > ABS(YMin) THEN
      Potenz = YMax
   ELSE
      Potenz = YMin
   END IF
   Potenz = CINT(LOG(ABS(Potenz) / 100) / LOG(10))
   IF Potenz < 0 THEN Potenz = 0
   ' Verkleinere minimalen und maximalen Wert:
   SkalFaktor = 10 ^ Potenz
   YMax = CINT(YMax / SkalFaktor)
   YMin = CINT(YMin / SkalFaktor)
   ' Wenn Potenz nicht Null ist, dann schreibe den
   ' Skalierungsfaktor in das Diagramm:
   IF Potenz <> 0 THEN
      LOCATE 3, 2
      PRINT "x 10^"; LTRIM$(STR$(Potenz))
   END IF
   ' Setze Markierungsstrich und Zahl fr maximalen
   ' Punkt an die y-Achse:
   LINE (GRAPHLINKS - 3, GRAPHOBEN)-STEP(3, 0)
   LOCATE 4, 2
   PRINT USING "####"; YMax
   ' Setze Markierungsstrich und Zahl fr minimalen
   ' Punkt an die y-Achse:
   LINE (GRAPHLINKS - 3, GRAPHUNTEN)-STEP(3, 0)
   LOCATE 22, 2
   PRINT USING "####"; YMin
   YMax = YMax * SkalFaktor ' Vergrere Minimum und
			    ' Maximum wieder
   YMin = YMin * SkalFaktor ' zur grafischen
			    ' Darstellung der
			    ' Berechnungen.
   ' Bezeichne x-Achse:
   Start% = 44 - (LEN(RTRIM$(T.XTitel)) / 2)
   LOCATE 25, Start%
   PRINT RTRIM$(T.XTitel);
   ' Berechne den Bildpunktebereich fr die y-Achse:
   YBereich = YMax - YMin
   ' Definiere ein diagonal gestreiftes Muster:
   Kachel$ = CHR$(1) + CHR$(2) + CHR$(4) + CHR$(8) + CHR$(16) + CHR$(32) + CHR$(64) + CHR$(128)
   ' Zeichne eine Null-Linie, falls passend:
   IF YMin < 0 THEN
      Unten = GRAPHUNTEN - ((-YMin) / YBereich * YLANG)
      LOCATE INT((Unten - 1) / 8) + 1, 5
      PRINT "0";
   ELSE
      Unten = GRAPHUNTEN
   END IF
   ' Zeichne die x-Achse:
   LINE (GRAPHLINKS - 3, Unten)-(GRAPHRECHTS, Unten)
   ' Zeichne die Balken und Bezeichnungen:
   Start% = GRAPHLINKS + (BalkZwisch / 2)
   FOR I% = 1 TO N%
      ' Zeichne eine Balkenbezeichnung:
      BalkMitt = Start% + (BalkBreit / 2)
      DiagrMitt = INT((BalkMitt - 1) / 8) + 1
      LOCATE 23, DiagrMitt - INT(LEN(RTRIM$(bezeich$(I%))) / 2)
      PRINT bezeich$(I%);
      ' Zeichne den Balken und flle ihn mit dem
      ' gestreiften Muster aus:
      BalkHoehe = (Wert(I%) / YBereich) * YLANG
      LINE (Start%, Unten)-STEP(BalkBreit, -BalkHoehe), , B
      PAINT (BalkMitt, Unten - (BalkHoehe / 2)), Kachel$, 1
      Start% = Start% + BalkBreit + BalkZwisch
   NEXT I%
   LOCATE 1, 1
   PRINT "Neues Diagramm? ";
   Diagramm$ = UCASE$(INPUT$(1))
END FUNCTION

'
' ==================== EINGABDATEN ===================
'       Liest Eingabe fr die Balkenbezeichnungen
'       und deren Werte
' ====================================================
'
FUNCTION EingabDaten% (bezeich$(), Wert()) STATIC
   ' Initialisiere die Anzahl der Datenwerte:
   AnzDaten% = 0
   ' Gib Anweisungen fr Dateneingabe aus:
   CLS
   PRINT "Geben Sie Daten fr bis zu 5 Balken ein:"
   PRINT "   * Geben Sie die Bezeichnung und den Wert fr jeden Balken ein."
   PRINT "   * Werte knnen negativ sein."
   PRINT "   * Geben Sie eine leere Bezeichnung zum Beenden ein."
   PRINT
   PRINT "Nachdem Sie das Diagramm gesehen haben, bettigen Sie eine Taste"
   PRINT "zum Beenden des Programms."
   ' Nimm Daten bis zu einer leeren Bezeichnung
   ' oder 5 Eintrgen an:
   Fertig% = FALSCH
   DO
      AnzDaten% = AnzDaten% + 1
      PRINT
      PRINT "Balken("; LTRIM$(STR$(AnzDaten%)); "):";
      INPUT ; " Bezeichnung? ", bezeich$(AnzDaten%)
      ' Eingabe eines Wertes nur, wenn Bezeichnung
      ' nicht leer ist:
      IF bezeich$(AnzDaten%) <> "" THEN
	 entf = LEN(bezeich$(AnzDaten%)) + 30
	 IF entf > 70 THEN entf = (entf \ 80)
	 LOCATE , entf
	 INPUT "Wert? ", Wert(AnzDaten%)
      ' Wenn Bezeichnung leer ist, vermindere den
      ' Datenzhler und setze Flagge fr Fertig auf
      ' WAHR:
      ELSE
	 AnzDaten% = AnzDaten% - 1
	 Fertig% = WAHR
      END IF
   LOOP UNTIL (AnzDaten% = 5) OR Fertig%
   ' Gib die Anzahl der eingegebenen Datenwerte
   ' zurck:
   EingabDaten% = AnzDaten%
END FUNCTION

'
' ================== EINGABTITEL ====================
'       Akzeptiert Eingabe fr die drei
'       unterschiedlichen Diagrammtitel
' ====================================================
'
SUB EingabTitel (T AS TitelTyp) STATIC
   SCREEN 0, 0    ' Setze Textbildschirm.
   DO             ' Eingabe der Titel.
      CLS
      INPUT "Geben Sie die berschrift des Diagramms ein : ", T.HauptTitel
      INPUT "Geben Sie die Bezeichnung der x-Achse ein   : ", T.XTitel
      INPUT "Geben Sie die Bezeichnung der y-Achse ein   : ", T.YTitel
      ' berprfe, ob Titel in Ordnung sind:
      LOCATE 7, 1
      PRINT "Eingaben korrekt? J/N ";
      LOCATE , , 1
      OK$ = UCASE$(INPUT$(1))
   LOOP UNTIL OK$ = "J"
END SUB

