' Deklariere die im Programm verwendeten symbolischen
' Konstanten:
CONST FALSCH = 0, WAHR = NOT FALSCH
DECLARE FUNCTION LiesDateiName$ ()
' Schalte die FEHLER-Verfolgung ein und gib den Namen
' der Fehlerbehandlungsroutine an:
ON ERROR GOTO FehlerProz
DO
   Neustart = FALSCH
   CLS
   DateiName$ = LiesDateiName$   ' Eingabe des
				 ' Dateinamens.
   IF DateiName$ = "" THEN
      END                   ' Beende, wenn die
			    ' <EINGABETASTE>
			    ' bettigt wird.
   ELSE
      ' Anderenfalls ffne die Datei; weise ihr dabei
      ' die nchste verfgbare Dateinummer zu
      DateiNum = FREEFILE
      OPEN DateiName$ FOR INPUT AS DateiNum
   END IF
   IF NOT Neustart THEN
      ' Gib zu suchende Zeichenkette ein:
      LINE INPUT "Geben Sie die zu suchende Zeichenkette ein: ", SuchKette$
      SuchKette$ = UCASE$(SuchKette$)
      ' Durchlaufe die Zeilen der Datei und gib diese
      ' aus, wenn sie die zu suchende Zeichenkette
      ' enthalten:
      ZeileNum = 1
      DO WHILE NOT EOF(DateiNum)
	 ' Einlesen einer Zeile aus der Datei:
	 LINE INPUT #DateiNum, ZeilePuffer$
	 ' Prfe auf Zeichenkette und gib die Zeile
	 ' sowie deren Nummer aus, wenn gefunden:
	 IF INSTR(UCASE$(ZeilePuffer$), SuchKette$) <> 0 THEN
	    PRINT USING "#### &"; ZeileNum, ZeilePuffer$
	 END IF
	 ZeileNum = ZeileNum + 1
      LOOP
      CLOSE DateiNum      ' Schliee die Datei.
   END IF
LOOP WHILE Neustart = WAHR
END
FehlerProz:
   SELECT CASE ERR
      CASE 64:               ' Unzulssiger Dateiname
	 PRINT "** FEHLER - Unzulssiger Dateiname"
	 ' Lies einen neuen Dateinamen und versuche
	 ' erneut:
	 DateiName$ = LiesDateiName$
	 ' Fahre mit der Anweisung fort, die den
	 ' Fehler verursachte:
	 RESUME
      CASE 71:                ' Diskette nicht bereit
	 PRINT "** FEHLER - Diskette nicht bereit"
	 PRINT "Bettige F zum Fortfahren, N zum Neustart, B zum Beenden: "
	 DO
	   Zeich$ = UCASE$(INPUT$(1))
	   IF Zeich$ = "F" THEN
	      RESUME         ' Fahre fort, wo du
			     ' beendet hast.
	   ELSEIF Zeich$ = "N" THEN
	      Neustart = WAHR   ' Fahre am Beginn
	      RESUME NEXT       ' fort.
	   ELSEIF Zeich$ = "B" THEN
	      END        ' Fahre berhaupt nicht fort.
	   END IF
	 LOOP
      CASE 53, 76:              ' Datei oder Pfad
				' nicht gefunden.
	 PRINT "** FEHLER - Datei oder Pfad nicht gefunden"
	 DateiName$ = LiesDateiName$
	 RESUME
      CASE ELSE:            ' Unvorhergesehener Fehler
	 ' Schalte Fehlerverfolgung aus und gib
	 ' Standard-Systemmeldung aus:
	 ON ERROR GOTO 0
   END SELECT

'
' ================== LIESDATEINAME$ ==================
'   Gibt eine vom Benutzer eingegebene Datei zurck
' ====================================================
'
FUNCTION LiesDateiName$ STATIC
   PRINT "Gib zu durchsuchende Datei ein (bettige EINGABETASTE zum Beenden):"
   INPUT DTemp$
   LiesDateiName$ = DTemp$
END FUNCTION

