DECLARE SUB ZeichneMuster ()
DECLARE SUB EditMuster ()
DECLARE SUB Initialisiere ()
DECLARE SUB ZeigMuster (OK$)
DIM Bit%(0 TO 7), Muster$, Esc$, MusterGross%
DO
   Initialisiere
   EditMuster
   ZeigMuster OK$
LOOP WHILE OK$ = "J"
END

'
'==================== EDITMUSTER =====================
'           Editiert ein Kachel-Bytemuster
'=====================================================
'
SUB EditMuster STATIC
SHARED Muster$, Esc$, Bit%(), MusterGross%
   ByteZahl% = 1    ' Anfangsposition.
   BitZahl% = 7
   Null$ = CHR$(0)  ' CHR$(0) ist das erste
		    ' zurckgegebene Byte, wenn eine
		    ' Richtungstaste wie OBEN oder
		    ' UNTEN bettigt wurde.
   DO
      ' Berechne Anfangsposition dieses Bits auf dem
      ' Bildschirm:
      X% = ((7 - BitZahl%) * 16) + 80
      Y% = (ByteZahl% + 2) * 8
      ' Warte auf Tastenbettigung (und lasse Cursor
      ' alle 3/10 Sekunden blinken):
      Zustand% = 0
      AufZeit = 0
      DO
      ' Prfe Zeitgeber und wechsele Cursor-Zustand,
      ' wenn 3/10 Sekunden vergangen sind:
      IF ABS(TIMER - AufZeit) > .3 THEN
	 AufZeit = TIMER
	 Zustand% = 1 - Zustand%
	 ' Schalte Rahmen des Bits ein und aus:
	 LINE (X% - 1, Y% - 1)-STEP(15, 8), Zustand%, B
      END IF
      Pruef$ = INKEY$   ' Prfe auf Tastenbettigung.
      LOOP WHILE Pruef$ = "" ' Durchlaufe Schleife,
			     ' bis eine Taste bettigt
			     ' ist.
      ' Lsche Cursor:
      LINE (X% - 1, Y% - 1)-STEP(15, 8), 0, B
      SELECT CASE Pruef$  ' Reagiere auf
			  ' Tastenbettigung.
	 CASE CHR$(27)    ' ESC-Taste bettigt:
	    EXIT SUB      ' verlasse dieses
			  ' Unterprogramm.
	 CASE CHR$(32)    ' LEERTASTE bettigt:
			  ' setze Zustand des Bits
			  ' neu.
	    ' Invertiere Bit in der
	    ' Musterzeichenkette:
	    AktuellByte% = ASC(MID$(Muster$, ByteZahl%, 1))
	    AktuellByte% = AktuellByte% XOR Bit%(BitZahl%)
	    MID$(Muster$, ByteZahl%) = CHR$(AktuellByte%)
	    ' Zeichne Bit neu auf den Bildschirm:
	    IF (AktuellByte% AND Bit%(BitZahl%)) <> 0 THEN
	       AktuellFarbe% = 1
	    ELSE
	       AktuellFarbe% = 0
	    END IF
	    LINE (X% + 1, Y% + 1)-STEP(11, 4), AktuellFarbe%, BF
	 CASE CHR$(13)     ' EINGABETASTE bettigt:
	    ZeichneMuster  ' zeichne Muster im rechten
			   ' Rechteck.
	 CASE Null$ + CHR$(75)  ' LINKS-Taste: bewege
				' Cursor nach links.
	    BitZahl% = BitZahl% + 1
	    IF BitZahl% > 7 THEN BitZahl% = 0
	 CASE Null$ + CHR$(77)  ' RECHTS-Taste: bewege
				' Cursor nach rechts.
	    BitZahl% = BitZahl% - 1
	    IF BitZahl% < 0 THEN BitZahl% = 7
	 CASE Null$ + CHR$(72)  ' OBEN-Taste: bewege
				' Cursor nach oben.
	    ByteZahl% = ByteZahl% - 1
	    IF ByteZahl% < 1 THEN ByteZahl% = MusterGross%
	 CASE Null$ + CHR$(80)  ' UNTEN-Taste: bewege
				' Cursor nach unten.
	    ByteZahl% = ByteZahl% + 1
	    IF ByteZahl% > MusterGross% THEN ByteZahl% = 1
	 CASE ELSE
	    ' Benutzer hat eine andere Taste als ESC,
	    ' LEERTASTE, EINGABETASTE, OBEN, UNTEN,
	    ' LINKS oder RECHTS bettigt, also tue
	    ' nichts.
      END SELECT
   LOOP
END SUB

'
' ================== INITIALISIERE ===================
'      Initialisiert Anfangsmuster und Bildschirm.
' ====================================================
'
SUB Initialisiere STATIC
SHARED Muster$, Esc$, Bit%(), MusterGross%
   Esc$ = CHR$(27)    ' ESC-Zeichen ist ASCII 27.
   ' Initialisiere ein Datenfeld, das Bits in den
   ' Positionen 0 bis 7 enthlt:
   FOR I% = 0 TO 7
      Bit%(I%) = 2 ^ I%
   NEXT I%
   CLS
   ' Eingabe der Gre des Musters (in Anzahl an
   ' Bytes):
   LOCATE 5, 5
   PRINT "Geben Sie die Gre des Musters ein (1-16 Zeilen):";
   DO
      LOCATE 5, 58
      PRINT "     ";
      LOCATE 5, 58
      INPUT "", MusterGross%
   LOOP WHILE MusterGross% < 1 OR MusterGross% > 16
   ' Setze Anfangsmuster auf alle gesetzten Bits:
   Muster$ = STRING$(MusterGross%, 255)
   SCREEN 2    ' 640 x 200 monochromer Grafikmodus
   ' Zeichne Trennungslinien:
   LINE (0, 10)-(635, 10), 1
   LINE (300, 0)-(300, 199)
   LINE (302, 0)-(302, 199)
   ' Schreibe berschriften:
   LOCATE 1, 13: PRINT "Musterbytes"
   LOCATE 1, 53: PRINT "Musteransicht"
   ' Zeichne Editierbildschirm fr das Muster:
   FOR I% = 1 TO MusterGross%
      ' Gib links von jeder Zeile Bezeichnung aus:
      LOCATE I% + 3, 8
      PRINT USING "##:"; I%
      ' Zeichne "Bit"-Rechtecke:
      X% = 80
      Y% = (I% + 2) * 8
      FOR J% = 1 TO 8
	LINE (X%, Y%)-STEP(13, 6), 1, BF
	X% = X% + 16
      NEXT J%
   NEXT I%
   ZeichneMuster   ' Zeichne "Musteransicht"-Rechteck.
   LOCATE 21, 1
   PRINT "RICHTUNGSTASTEN........Bewegen Cursor"
   PRINT "LEERTASTE.............Verndert Punkt"
   PRINT "EINGABETASTE.....Anzeigen des Musters"
   PRINT "ESC...........................Beendet";
END SUB

'
' =================== ZEICHNEMUSTER ==================
'       Zeichnet ein gemustertes Rechteck auf der
'       rechten Seite des Bildschirms.
' ====================================================
'
SUB ZeichneMuster STATIC
SHARED Muster$
   VIEW (320, 24)-(622, 160), 0, 1 ' Setze Feld auf
				   ' Rechteck.
   PAINT (1, 1), Muster$     ' Verwende PAINT, um es
			     ' auszufllen.
   VIEW                      ' Setze Feld auf gesamten
			     ' Bildschirm.
END SUB

'
' ==================== ZEIGMUSTER ====================
'     Gibt die von PAINT zum Erstellen des Musters
'     verwendeten CHR$-Werte
' ====================================================
'
SUB ZeigMuster (OK$) STATIC
SHARED Muster$, MusterGross%
   ' Schalte Bildschirm zurck in 80-Spalten Textmodus:
   SCREEN 0, 0
   WIDTH 80
   PRINT "Die folgenden Zeichen erstellen Ihr Muster:"
   PRINT
   ' Gib den Wert fr jedes Musterbyte aus:
   FOR I% = 1 TO MusterGross%
      MusterByte% = ASC(MID$(Muster$, I%, 1))
      PRINT "CHR$("; LTRIM$(STR$(MusterByte%)); ")"
   NEXT I%
   PRINT
   LOCATE , , 1
   PRINT "Neues Muster? (J/N)";
   OK$ = UCASE$(INPUT$(1))
END SUB

