
' ENTAB.BAS
'
' Programm, welches Folgen von Leerschritten in einer Dateidurch
' Tabulatoren ersetzt

DECLARE SUB SetzeTabPos ()
DECLARE SUB IntBefehl (BefZeile$)

DEFINT A-Z
DECLARE FUNCTION DiesIstEinTab (Spalte AS INTEGER)

CONST MAXZEILE = 255
Tababst = 8
CONST NEIN = 0, JA = NOT NEIN

DIM SHARED TabStops(MAXZEILE)  AS INTEGER

IntBefehl (COMMAND$)

' Setze die Tabulator-Positionen (verwendet das globale
'Datenfeld TabStops).
SetzeTabPos

LetzteSpalte = 1

DO

    AktuelleSpalte = LetzteSpalte

' Ersetze eine Folge von Leerzeichen mit einem Tabulator wenn eine
' Tab-Spalte erreicht wird. AktuelleSpalte ist die aktuell
' gelesene Spalte. LetzteSpalte ist die zuletzt ausgegebene Spalte.
   DO
      B$ = INPUT$(1, #1)
      IF B$ <> " " AND B$ <> CHR$(9) THEN EXIT DO
      AktuelleSpalte = AktuelleSpalte + 1
      IF B$ = CHR$(9) OR DiesIstEinTab(AktuelleSpalte) THEN
         ' Gehe zu einer Tab-Spalte, wenn ein Tab vorliegt und dies keine
         ' Tab-Spalte ist.
         DO WHILE NOT DiesIstEinTab(AktuelleSpalte)
            AktuelleSpalte = AktuelleSpalte + 1
         LOOP
         PRINT #2, CHR$(9);
         LetzteSpalte = AktuelleSpalte
      END IF
   LOOP

' Gib briggebliebene Leerzeichen aus.
   DO WHILE LetzteSpalte < AktuelleSpalte
      PRINT #2, " ";
      LetzteSpalte = LetzteSpalte + 1
   LOOP

' Gib die Zeichen aus, die keine Leerzeichen sind.
   PRINT #2, B$;

' Setze die Spaltenposition zurck, wenn dies das Zeilenende ist.
   IF B$ = CHR$(10) THEN
      LetzteSpalte = 1
   ELSE
      LetzteSpalte = LetzteSpalte + 1
   END IF

LOOP UNTIL EOF(1)
CLOSE #1, #2
END

'-------------FUNCTION DiesIstEinTab------------
' Beantwortet die Frage, "Ist dieses eine Tabulator-
'Postion?"
'
FUNCTION DiesIstEinTab (LetzteSpalte AS INTEGER) STATIC
   IF LetzteSpalte > MAXZEILE THEN
      DiesIstEinTab = JA
   ELSE
      DiesIstEinTab = TabStops(LetzteSpalte)
   END IF
END FUNCTION

'
'------------------SUB IntBefehl----------------------
'
SUB IntBefehl (BefehlsZeile$) STATIC
   IF BefehlsZeile$ = "" THEN
      INPUT "Zu bearbeitende Datei: ", EinDateiName$
      INPUT "Speichere modifizierte Datei als: ", AusDateiName$
   ELSE
      LeerzeichenPos = INSTR(BefehlsZeile$, " ")
      IF LeerzeichenPos > 0 THEN
         EinDateiName$ = LEFT$(BefehlsZeile$, LeerzeichenPos - 1)
         AusDateiName$ = LTRIM$(MID$(BefehlsZeile$, LeerzeichenPos))
      ELSE
         EinDateiName$ = BefehlsZeile$
         INPUT "Speichere modifizierte Datei als: ", AusDateiName$
      END IF
   END IF
   OPEN EinDateiName$ FOR INPUT AS #1
   OPEN AusDateiName$ FOR OUTPUT AS #2
END SUB

'---------SUB SetzeTabPos-----------------------
' Setze die Tabulatorposition in dem Datenfeld
' TabStops
'
SUB SetzeTabPos STATIC
SHARED Tababst
   FOR I = 1 TO MAXZEILE
      TabStops(I) = ((I MOD Tababst) = 1)
   NEXT I
END SUB

