DEFINT A-Z

' Definiere die symbolischen Konstanten, die in dem
' Programm global verwendet werden:
CONST FALSCH = 0, WAHR = NOT FALSCH

' Definiere eine Verbundstruktur fr Stze einer
' Direktzugriffsdatei:
TYPE BestPosten
   TeilNummer AS STRING * 6
   Beschreib  AS STRING * 20
   EinzPreis  AS SINGLE
   Menge      AS INTEGER
END TYPE

' Definiere eine Verbundstruktur fr jedes Element des
' Index:
TYPE IndexTyp
   SatzNummer AS INTEGER
   TeilNummer AS STRING * 6
END TYPE
' Deklariere Prozeduren, die aufgerufen werden:
DECLARE FUNCTION Filter$ (Anfrage$)
DECLARE FUNCTION FindeSatz% (TeilNummer$, SatzVar AS BestPosten)
DECLARE SUB AddSatz (SatzVar AS BestPosten)
DECLARE SUB GibSatz (SatzVar AS BestPosten)
DECLARE SUB SchreibSatz (SatzVar AS BestPosten)
DECLARE SUB SortIndex ()
DECLARE SUB ZeigTeilNummer ()
' Definiere einen Puffer (der den Typ BestPosten
' verwendet) und definiere und dimensioniere das
' Indexdatenfeld:
DIM BestSatz AS BestPosten, Index(1 TO 100) AS IndexTyp
' ffne die Direktzugriffsdatei:
OPEN "BESTAND.DAT" FOR RANDOM AS #1 LEN = LEN(BestSatz)
' Berechne Anzahl der Stze in der Datei:
AnzSaetze = LOF(1) \ LEN(BestSatz)
' Wenn Stze vorhanden sind, lies sie und bilde den
' Index:
IF AnzSaetze <> 0 THEN
   FOR SatzNummer = 1 TO AnzSaetze
      ' Lies die Daten eines neuen Satzes der Datei:
      GET #1, SatzNummer, BestSatz
      ' Plaziere Teilenummer und Satznummer im Index:
      Index(SatzNummer).SatzNummer = SatzNummer
      Index(SatzNummer).TeilNummer = BestSatz.TeilNummer
   NEXT
   SortIndex      ' Sortiere Index in der Reihenfolge der
                  ' Teilenummern.
END IF
DO                      ' Schleife des Hauptmens
   CLS
   PRINT "(F)ge Stze hinzu."
   PRINT "(Z)eige Stze an."
   PRINT "(B)eende Programm."
   PRINT
   LOCATE , , 1
   PRINT "Whlen Sie (F, Z, oder B) hier: ";
   ' Warte, bis Benutzer F, Z oder B bettigt:
   DO
      Wahl$ = UCASE$(INPUT$(1))
   LOOP WHILE INSTR("FZB", Wahl$) = 0
   ' Verzweige entsprechend der Wahl:
   SELECT CASE Wahl$
      CASE "F"
         AddSatz BestSatz
      CASE "Z"
         IF AnzSaetze = 0 THEN
            PRINT : PRINT "Noch keine Stze in der Datei.";
            PRINT " Weiter mit jeder Taste.";
            Pause$ = INPUT$(1)
         ELSE
            GibSatz BestSatz
         END IF
      CASE "B"          ' Beende Programm.
   END SELECT
LOOP UNTIL Wahl$ = "B"
CLOSE #1   ' Alles fertig; schliee Datei und beende.
END
'
' ================= ZEIGTEILNUMMER ==================
'  Gibt einen Index aller Teilenummern im oberen
'  Teil des Bildschirms aus.
'====================================================

'
' ===================== ADDSATZ ======================
'  Fgt an die Datei Stze aus Tastatureingabe an.
' ====================================================
'
SUB AddSatz (SatzVar AS BestPosten) STATIC
   SHARED Index() AS IndexTyp, AnzSaetze
   DO
      CLS
      INPUT "Teilenummer : ", SatzVar.TeilNummer
      INPUT "Beschreibung: ", SatzVar.Beschreib
      ' Aufruf der FUNCTION Filter$, um Preis & Menge
      ' einzugeben:
      SatzVar.EinzPreis = VAL(Filter$("Einzelpreis : "))
      SatzVar.Menge = VAL(Filter$("Menge     : "))
      AnzSaetze = AnzSaetze + 1
      PUT #1, AnzSaetze, SatzVar
      Index(AnzSaetze).SatzNummer = AnzSaetze
      Index(AnzSaetze).TeilNummer = SatzVar.TeilNummer
      PRINT : PRINT "Weiter anfgen? (j/n)";
      OK$ = UCASE$(INPUT$(1))
   LOOP WHILE OK$ = "J"
   SortIndex            ' Sortiere Index-Datei erneut.
END SUB

'
' ===================== FILTER =======================
'       Filtert alle nicht-numerischen Zeichen aus
'       einer Zeichenkette und gibt die gefilterte
'       Zeichenkette zurck.
' ====================================================
'
FUNCTION Filter$ (Anfrage$) STATIC
   WertTemp2$ = ""
   PRINT Anfrage$;   ' Gib die bergebene Anfrage aus.
   INPUT "", WertTemp1$   ' Gib eine Zahl als
                          ' Zeichenkette an.
   KettLaenge = LEN(WertTemp1$)  ' Ermittle die Lnge
                                 ' der Zeichenkette.
   FOR I% = 1 TO KettLaenge      ' Gehe Zeichen fr
                                 ' Zeichen durch die
                                 ' Zeichenkette.
      Zeich$ = MID$(WertTemp1$, I%, 1)
      ' Ist das Zeichen ein gltiger Teil einer Zahl
      ' (d. h., eine Ziffer oder ein Dezimalpunkt)?
      ' Wenn ja, fge es an das Ende einer neuen
      ' Zeichenkette:
      IF INSTR(".0123456789", Zeich$) > 0 THEN
         WertTemp2$ = WertTemp2$ + Zeich$
      ' Andernfalls prfe, ob es ein kleines "l" ist,
      ' da an Schreibmaschinen gewohnte Benutzer eine
      ' 1 vielleicht auf diese Art eingeben:
      ELSEIF Zeich$ = "l" THEN
         WertTemp2$ = WertTemp2$ + "1" 'ndere das "l"
                                       'in eine "1".
      END IF
   NEXT I%
   Filter$ = WertTemp2$      ' Gib die gefilterte
                             ' Zeichenkette zurck.
END FUNCTION

'
' =================== FINDESATZ =====================
'     Verwendet einen binren Suchalgorithmus, um
'     einen Satz im Index ausfindig zu machen.
' ====================================================
'
FUNCTION FindeSatz% (Teil$, SatzVar AS BestPosten) STATIC
   SHARED Index() AS IndexTyp, AnzSaetze
   ' Setze Ober- und Untergrenze fr die Suche:
   ObSatz = AnzSaetze
   UntSatz = 1
   ' Suche, bis oberer Bereich kleiner als unterster
   ' ist:
   DO UNTIL (ObSatz < UntSatz)
      ' Whle Mittelpunkt:
      Mittpunkt = (ObSatz + UntSatz) \ 2
      ' berprfe, ob dies der gewnschte Satz ist
      ' (RTRIM$() entfernt nachfolgende Leerzeichen
      ' aus einer Zeichenkette fester Lnge):
      Test$ = RTRIM$(Index(Mittpunkt).TeilNummer)
      ' Wenn dies so ist, verlasse die Schleife:
      IF Test$ = Teil$ THEN
         EXIT DO
      ' Andernfalls, wenn das, wonach gesucht wird,
      ' grer ist, bewege unteres Ende nach oben:
      ELSEIF Teil$ > Test$ THEN
        UntSatz = Mittpunkt + 1
      ' Andernfalls bewege oberes Ende nach unten:
      ELSE
         ObSatz = Mittpunkt - 1
      END IF
   LOOP
   ' Wenn Teil gefunden wurde, lies Satz aus der Datei
   ' unter Verwendung des Zeigers im Index ein und
   ' setze FindeSatz% auf WAHR:
  IF Test$ = Teil$ THEN
      GET #1, Index(Mittpunkt).SatzNummer, SatzVar
      FindeSatz% = WAHR
   ' Andernfalls, wenn Teil nicht gefunden wurde,
   ' setze FindeSatz% auf FALSCH:
   ELSE
      FindeSatz% = FALSCH
   END IF
END FUNCTION

'
' ===================== GIBSATZ ======================
'    GIBSATZ ruft zunchst ZEIGTEILNUMMER auf, das
'    ein Men von Teilenummern im oberen Bereich des
'    Bildschirms ausgibt. Danach fordert GIBSATZ den
'    Benutzer auf, eine Teilenummer einzugeben.
'    Abschlieend ruft es die Prozeduren FINDESATZ und
'    SCHREIBSATZ auf, um den gegebenen Satz zu finden
'    und auszugeben.
' ====================================================
'
SUB GibSatz (SatzVar AS BestPosten) STATIC
   CLS
   ZeigTeilNummer   ' Rufe die SUB ZeigTeilNummer auf.
   ' Gib die Daten des angegebenen Satzes im
   ' unteren Teil des Bildschirms aus:
   DO
      PRINT "Geben Sie eine der oben aufgelisteten";
      PRINT " Teilenummern an (oder B zum Beenden) "
      INPUT "und bettigen Sie die <EINGABETASTE>: ", Teil$
      IF UCASE$(Teil$) <> "Q" THEN
         IF FindeSatz(Teil$, SatzVar) THEN
             SchreibSatz SatzVar
         ELSE
             PRINT "Teil nicht gefunden."
         END IF
      END IF
      PRINT STRING$(40, "_")
   LOOP WHILE UCASE$(Teil$) <> "B"
   VIEW PRINT  ' Stelle gesamten Bildschirm als Text-
               ' Darstellungsfeld wieder her.
END SUB

'
' =================== SCHREIBSATZ ====================
'       Gibt einen Satz auf den Bildschirm aus
' ====================================================
'
SUB SchreibSatz (SatzVar AS BestPosten) STATIC
   PRINT "Teilenummer : "; SatzVar.TeilNummer
   PRINT "Beschreibung: "; SatzVar.Beschreib
   PRINT USING "Einzelpreis:$$###.##"; SatzVar.EinzPreis
   PRINT "Menge   :"; SatzVar.Menge
END SUB

'
' ===================== SORTINDEX ====================
'             Sortiert den Index nach Teilenummern
' ====================================================
'
SUB SortIndex STATIC
   SHARED Index() AS IndexTyp, AnzSaetze
   ' Setze Vergleichsoffset gleich der Hlfte
   ' der Anzahl der Stze im Index
   Offset = AnzSaetze \ 2
   ' Wiederhole, bis Offset null wird:
   DO WHILE Offset > 0
      Limit = AnzSaetze - Offset
      DO
          ' Nimm an, kein Wechsel an diesem Offset:
          Wechsel = FALSCH
          ' Vergleiche Elemente und wechsele, wenn
          ' eines auerhalb der Reihenfolge:
          FOR I = 1 TO Limit
              IF Index(I).TeilNummer > Index(I + Offset).TeilNummer THEN
                SWAP Index(I), Index(I + Offset)
                Wechsel = I
             END IF
          NEXT I
          ' Sortiere im nchsten Schritt nur bis
          ' dahin, wo letzter Wechsel vorgenommen
          ' wurde:
          Limit = Wechsel
      LOOP WHILE Wechsel
      ' Keine Wechsel beim letzten Offset, versuche es
      ' mit einem halb so groen:
      Offset = Offset \ 2
   LOOP
END SUB

'
SUB ZeigTeilNummer STATIC
   SHARED Index() AS IndexTyp, AnzSaetze
   CONST ANZSPALTEN = 8, SPALTENBREIT = 80 \ ANZSPALTEN
   ' Gib im oberen Teil des Bildschirms ein Men aus,
   ' das alle Teilenummern fr Stze in der Datei
   ' indiziert. Dieses Men wird in Spalten gleicher
   ' Lnge ausgegeben (Ausnahme ist vielleicht die
   ' letzte Spalte, die krzer als die anderen sein
   ' kann):
   SpalteLang = AnzSaetze
   DO WHILE SpalteLang MOD ANZSPALTEN
      SpalteLang = SpalteLang + 1
   LOOP
   SpalteLang = SpalteLang \ ANZSPALTEN
   Spalte = 1
   SatzNummer = 1
   DO UNTIL SatzNummer > AnzSaetze
      FOR Zeile = 1 TO SpalteLang
         LOCATE Zeile, Spalte
         PRINT Index(SatzNummer).TeilNummer
         SatzNummer = SatzNummer + 1
         IF SatzNummer > AnzSaetze THEN EXIT FOR
      NEXT Zeile
      Spalte = Spalte + SPALTENBREIT
   LOOP
   LOCATE SpalteLang + 1, 1
   PRINT STRING$(80, "_")   ' Gib Trennzeile aus.
   ' Rolle Information ber die Stze unter dem
   ' Teilenummern-Men (auf diese Weise werden die
   ' Teilenummern nicht gelscht):
   VIEW PRINT SpalteLang + 2 TO 24
END SUB

