DEFINT A-Z    ' Standardvariablentyp ist Ganzzahl.
' Definiere einen Datentyp fr die Namen der Monate
' und die Anzahl von Tagen in jedem Monat:
TYPE MonatTyp
   Anzahl AS INTEGER   ' Anzahl von Tagen in dem Monat
   MName AS STRING * 9 ' Name des Monats
END TYPE
' Deklariere die verwendeten Prozeduren:
DECLARE FUNCTION IstSchaltJahr% (N%)
DECLARE FUNCTION HolEingabe% (Anfrage$, Zeile%, NiedWert%, HoherWert%)
DECLARE SUB SchreibKalender (Jahr%, Monat%)
DECLARE SUB BerechnMonat (Jahr%, Monat%, StartTag%, TotalTage%)
DIM MonatDatum(1 TO 12) AS MonatTyp
' Initialisiere Monatsdefinitionen mit den DATA-
' Anweisungen weiter unten:
FOR I = 1 TO 12
   READ MonatDatum(I).MName, MonatDatum(I).Anzahl
NEXT
' Hauptschleife, wiederhole fr soviele Monate wie
' gewnscht:
DO
   CLS
   ' Hole Jahr und Monat als Eingabe:
   Jahr = HolEingabe("Jahr (1899 to 2099): ", 1, 1899, 2099)
   Monat = HolEingabe("Monat (1 to 12): ", 2, 1, 12)
   ' Gib den Kalender aus:
   SchreibKalender Jahr, Monat
   ' Ein weiteres Datum?
   LOCATE 13, 1            ' Plaziere Cursor in Zeile
			   ' 13, Spalte 1.
   PRINT "Neues Datum? (j/n)";  ' Halte Cursor auf
			   ' derselben Zeile.
   LOCATE , , 1, 0, 13     ' Schalte Cursor ein und
			   ' la ihn ein Zeichen hoch
			   ' werden.
   Antw$ = INPUT$(1)       ' Warte auf Bettigen einer
			   ' Taste.
   PRINT Antw$             ' Gib bettigte Taste aus.
LOOP WHILE UCASE$(Antw$) = "J"
END
' Daten fr die Monate eines Jahres:
DATA Januar, 31, Februar, 28, Maerz, 31
DATA April, 30, Mai, 31, Juni, 30, Juli, 31, August,    31
DATA September, 30, Oktober, 31, November, 30, Dezember, 31

'
' ================== BERECHNMONAT ====================
'     Berechne den ersten Tag und die Anzahl der Tage
'     eines Monats
' ====================================================
'
SUB BerechnMonat (Jahr, Monat, StartTag, TotalTage) STATIC
   SHARED MonatDatum() AS MonatTyp
   CONST SCHALT = 366 MOD 7
   CONST NORMAL = 365 MOD 7
   ' Berechne Gesamtzahl der Tage (AnzTage) seit
   ' 1.1.1899.
   ' Beginne mit den ganzen Jahren:
   AnzTage = 0
   FOR I = 1899 TO Jahr - 1
      IF IstSchaltJahr(I) THEN       'Wenn Schaltjahr,
	AnzTage = AnzTage + SCHALT   'addiere 366 MOD 7.
      ELSE                           'Wenn normales
	AnzTage = AnzTage + NORMAL   'Jahr, addiere
      END IF                         '365 MOD 7.
   NEXT
   ' Addiere nun die Tage der ganzen Monate:
   FOR I = 1 TO Monat - 1
      AnzTage = AnzTage + MonatDatum(I).Anzahl
   NEXT
   ' Setze die Anzahl von Tagen in dem gewnschten
   ' Monat:
   TotalTage = MonatDatum(Monat).Anzahl
   ' Gleiche aus, wenn gewnschtes Jahr ein Schaltjahr
   ' ist:
   IF IstSchaltJahr(Jahr) THEN
      ' Wenn nach Februar, addiere eins zu den
      ' gesamten Tagen:
      IF Monat > 2 THEN
	 AnzTage = AnzTage + 1
      ' Wenn Februar, addiere eins zu den Tagen des
      ' Monats:
      ELSEIF Monat = 2 THEN
	 TotalTage = TotalTage + 1
      END IF
   END IF
   ' Der 1.1.1899 war ein Sonntag, daher ergibt die
   ' Berechnung von "AnzTage MOD 7" den Wochentag
   ' (Sonntag = 0, Montag = 1, Dienstag = 2, und so
   ' weiter) des ersten Tages fr den eingegebenen
   ' Monat:
   StartTag = AnzTage MOD 7
END SUB

'
' =================== HOLEINGABE =====================
'     Fordert zur Eingabe auf und testet dann auf
'     gltigen Bereich
' ====================================================
'
FUNCTION HolEingabe (Anfrage$, Zeile, NiedWert, HoherWert) STATIC
   ' Positioniere Anfrage in der angegebenen Zeile,
   ' schalte den Cursor ein und la ihn ein Zeichen
   ' hoch werden:
   LOCATE Zeile, 1, 1, 0, 13
   PRINT Anfrage$;
   ' Sichere Spaltenposition:
   Spalte = POS(0)
   ' Gib Wert ein, bis er innerhalb des Bereiches
   ' liegt:
   DO
      LOCATE Zeile, Spalte   ' Positioniere Cursor an
			     ' das Ende der Anfrage.
      PRINT SPACE$(10)       ' Lsche alles bereits
			     ' vorhandene.
      LOCATE Zeile, Spalte   ' Positoniere Cursor
			     ' hinter Anfrage.
      INPUT "", Wert         ' Gib Wert ohne Anfrage
			     ' ein.
   LOOP WHILE (Wert < NiedWert OR Wert > HoherWert)
   ' Gib gltige Eingabe als Wert der Funktion zurck:
   HolEingabe = Wert
END FUNCTION

'
' ================ ISTSCHALTJAHR =====================
' Bestimmt, ob ein Jahr ein Schaltjahr ist oder nicht
' ====================================================
'
FUNCTION IstSchaltJahr (N) STATIC
   ' Wenn das Jahr ohne Rest durch vier aber nicht
   ' durch 100 teilbar ist, oder wenn das Jahr ohne
   ' Rest durch 400 teilbar ist, dann ist es ein
   ' Schaltjahr:
   IstSchaltJahr = (N MOD 4 = 0 AND N MOD 100 <> 0) OR (N MOD 400 = 0)
END FUNCTION

'
' ================ SCHREIBKALENDER ===================
'   Gibt einen formatierten Kalender fr den Monat
'   in dem gegebenen Jahr aus
' ====================================================
'
SUB SchreibKalender (Jahr, Monat) STATIC
SHARED MonatDatum() AS MonatTyp
   ' Berechne den ersten Tag (So Mo Di ...) und die
   'Anzahl der Tage des Monats:
   BerechnMonat Jahr, Monat, StartTag, TotalTage
   CLS
   Kopf$ = RTRIM$(MonatDatum(Monat).MName) + "," + STR$(Jahr)
   ' Berechne Stelle zur Zentrierung von Monat und
   ' Jahr:
   LinkRand = (35 - LEN(Kopf$)) \ 2
   ' Gib Kopf aus:
   PRINT TAB(LinkRand); Kopf$
   PRINT
   PRINT "So   Mo   Di   Mi   Do   Fr    Sa"
   PRINT
   ' Berechne erneut und gib Tab zum ersten Tag des
   ' Monats (So Mo Di ...) aus:
   LinkRand = 5 * StartTag + 1
   PRINT TAB(LinkRand);
   ' Gib die Tage des Monats aus:
   FOR I = 1 TO TotalTage
      PRINT USING "##   "; I;
      ' Springe auf nchste Zeile, wenn Cursor sich
      ' hinter Spalte 32 befindet:
      IF POS(0) > 32 THEN PRINT
   NEXT
END SUB

