DEFINT A-Z      ' Standardvariablentyp ist Ganzzahl.
DECLARE SUB AenderPalette ()
DECLARE SUB FenstWerte (FL%, FR%, FO%, FU%)
DECLARE SUB MonitorTest (EM%, FB%, DL%, DR%, DOB%, DU%)
CONST FALSCH = 0, WAHR = NOT FALSCH  ' Boolesche
                                     ' Konstanten
' Lege maximale Anzahl an Iterationen pro Punkt fest:
CONST MAXSCHLEIFE = 30, MAXGROSS = 1000000
DIM PaletteFeld(15)
FOR I = 0 TO 15: PaletteFeld(I) = I: NEXT I
' Rufe FenstWerte auf, um Koordinaten der Ecken des
' Fensters zu bekommen:
FenstWerte WLinks, WRechts, WOben, WUnten
' Rufe MonitorTest auf um herauszufinden, ob es sich
' um einen Rechner mit EGA handelt, und lies
' Koordinaten der Ecken des Darstellungsfeldes:
MonitorTest EgaModus, FarbeBereich, VLinks, VRechts, VOben, VUnten
' Definiere Darstellungsfeld und entsprechendes
' Fenster:
VIEW (VLinks, VOben)-(VRechts, VUnten), 0, FarbeBereich
WINDOW (WLinks, WOben)-(WRechts, WUnten)
LOCATE 24, 10: PRINT "Beliebige Taste zum Beenden.";
XLaenge = VRechts - VLinks
YLaenge = VUnten - VOben
FarbeBreit = MAXSCHLEIFE \ FarbeBereich
' Bearbeite jeden Bildpunkt im Darstellungsfeld und
' berechne, ob er sich in der Mandelbrot-Menge
' befindet oder nicht:
FOR Y = 0 TO YLaenge   ' Durchlaufe jede Zeile des
                       ' Darstellungsfeldes.
   LogikY = PMAP(Y, 3) ' Lies die logische
                       ' y-Koordinate des Bildpunktes.
   PSET (WLinks, LogikY)  ' Zeichne den uerst linken
                          ' Bildpunkt einer Zeile.
   AltFarbe = 0    ' Beginne mit der Hintergrundfarbe.
   FOR X = 0 TO XLaenge   ' Durchlaufe jeden Bildpunkt
                          ' einer Zeile.
      LogikX = PMAP(X, 2) ' Lies die logische
                          ' x-Koordinate des
                          ' Bildpunktes.
      MandelX& = LogikX
      MandelY& = LogikY
      ' Fhre die Berechnungen aus, um festzustellen,
      ' ob dieser Punkt sich in der Mandelbrot-Menge
      ' befindet.
      FOR I = 1 TO MAXSCHLEIFE
         RealZahl& = MandelX& * MandelX&
         ImagZahl& = MandelY& * MandelY&
         IF (RealZahl& + ImagZahl&) >= MAXGROSS THEN EXIT FOR
         MandelY& = (MandelX& * MandelY&) \ 250 + LogikY
         MandelX& = (RealZahl& - ImagZahl&) \ 500 + LogikX
      NEXT I
      ' Weise dem Punkt eine Farbe zu:
      PFarbe = I \ FarbeBreit
      ' Wenn die Farbe gewechselt hat, zeichne eine
      ' Zeile von dem letzten Punkt, auf den Bezug
      ' genommen wurde, zu dem neuen Punkt und
      ' verwende die alte Farbe:
      IF PFarbe <> AltFarbe THEN
        LINE -(LogikX, LogikY), (FarbeBereich - AltFarbe)
        AltFarbe = PFarbe
      END IF
      IF INKEY$ <> "" THEN END
   NEXT X
   ' Zeichne den letzten Zeilenabschnitt zur rechten
   ' Seite des Darstellungsfeldes:
   LINE -(LogikX, LogikY), (FarbeBereich - AltFarbe)
   ' Wenn es sich um eine EGA-Maschine handelt, ndere
   ' die Palette nach dem Zeichnen jeder Zeile:
   IF EgaModus THEN AenderPalette
NEXT Y
DO
   ' Verndere die Palette solange, bis der Benutzer
   ' eine Taste bettigt:
   IF EgaModus THEN AenderPalette
LOOP WHILE INKEY$ = ""
SCREEN 0, 0       ' Schalte den Bildschirm wieder auf
WIDTH 80          ' den Textmodus, 80 Spalten.
END
FalschMonit:          ' Fehlerbehandlung, die aufgeru-
   EgaModus = FALSCH  ' fen wird, wenn keine EGA-
   RESUME NEXT        ' Grafikkarte vorhanden ist.

'
' ================= AenderPalette ====================
'   Verschiebt die Palette bei jedem Aufruf um eins
' ====================================================
'
SUB AenderPalette STATIC
   SHARED PaletteFeld(), FarbeBereich
   FOR I = 1 TO FarbeBereich
      PaletteFeld(I) = (PaletteFeld(I) MOD FarbeBereich) + 1
   NEXT I
   PALETTE USING PaletteFeld(0)
END SUB

'
' =================== FenstWerte ======================
'   Liest Fensterecken als Benutzereingabe oder setzt
'   die Werte der Ecken, wenn keine Eingabe vorhanden
'   ist.
' =====================================================
'
SUB FenstWerte (FL, FR, FO, FU) STATIC
   CLS
   PRINT "Dieses Programm druckt die grafische Darstellung der vollstndigen"
   PRINT "Mandelbrot-Menge. Das Standardfenster reicht von (-1000,625) bis"
   PRINT "(250,-625). Zum Vergrern eines Teils der Figur geben Sie"
   PRINT "Koordinaten innerhalb dieses Fensters ein."
   PRINT
   PRINT "Nach Bettigen von <EINGABETASTE> sehen Sie das Standardfenster."
   PRINT "Bettigen Sie eine andere Taste, um eigene Fensterkoordinaten"
   PRINT "einzugeben:";
   LOCATE , , 1
   Antw$ = INPUT$(1)
   ' Benutzer hat EINGABETASTE nicht bettigt, also
   ' lies Fensterecken ein:
   IF Antw$ <> CHR$(13) THEN
      PRINT
      INPUT "X-Koordinate der oberen linken Ecke: ", FL
      DO
         INPUT "X-Koordinate der unteren rechten Ecke:    ", FR
         IF FR <= FL THEN
            PRINT "Rechte Ecke mu grer als linke Ecke sein."
         END IF
      LOOP WHILE FR <= FL
      INPUT "Y-Koordinate der oberen linken Ecke: ", FO
      DO
         INPUT "Y-Koordinate der unteren rechten Ecke:    ", FU
         IF FU >= FO THEN
            PRINT "Untere Ecke mu kleiner als obere Ecke sein."
         END IF
      LOOP WHILE FU >= FO
   ' Benutzer bettigte EINGABETASTE, also setze
   ' Standardwerte:
   ELSE
      FL = -1000
      FR = 250
      FO = 625
      FU = -625
   END IF
END SUB

'
' =================== MonitorTest ===================
' Verwendet eine Anweisung SCREEN 8 als Prfung, ob
' der Benutzer EGA-Hardware einsetzt. Wenn sich dabei
' ein Fehler ergibt, wird die EM-Flagge auf FALSCH
' gesetzt, und der Bildschirm wird mit SCREEN 1
' gesetzt.
'
' Setzt ebenso Werte fr die Ecken des
' Darstellungsfeldes (DL = Links, DR = Rechts,
' DOB = Oben, DU = Unten), skaliert mit dem
' richtigen Bildverhltnis, so da das
' Darstellungsfeld wirklich ein Quadrat ist.
' ====================================================
'
SUB MonitorTest (EM, FB, DL, DR, DOB, DU) STATIC
   EM = WAHR
   ON ERROR GOTO FalschMonit
   SCREEN 8, 1
   ON ERROR GOTO 0
   IF EM THEN     ' Kein Fehler, also ist SCREEN 8 OK.
      DL = 110: DR = 529
      DOB = 5: DU = 179
      FB = 15     ' 16 Farben (0 - 15)
   ELSE           ' Fehler, also verwende SCREEN 1.
      SCREEN 1, 1
      DL = 55: DR = 264
      DOB = 5: DU = 179
      FB = 3      ' 4 Farben (0 - 3)
   END IF
END SUB

