
DEFINT A-Z
' Deklariere die im Programm verwendeten symbolischen
' Konstanten:
CONST EOFTYP = 0, DATEITYP = 1, DIRTYP = 2, ROOT = "TWH"
DECLARE SUB SuchVerz (Pfad$, Ebene, DateiAng$, Zeile)
DECLARE FUNCTION ErstDateiNam$ (Zahl)
DECLARE FUNCTION HolEintr$ (DateiZahl, EintrTyp)
CLS
INPUT "Zu suchende Datei"; DateiAng$
PRINT
PRINT "Geben Sie das Verzeichnis ein, ";
PRINT "ab dem gesucht werden soll"
PRINT "(optional Laufwerk + Verzeichnisse)."
PRINT "Bettigen Sie die Eingabetaste, um die Suche im ";
PRINT "Hauptverzeichnis des aktuellen Laufwerks zu "
PRINT "beginnen."
PRINT
INPUT "Startverzeichnis"; Pfad$
CLS
RechtsZeich$ = RIGHT$(Pfad$, 1)
IF Pfad$ = "" OR RechtsZeich$ = ":" OR RechtsZeich$ <> "\" THEN
   Pfad$ = Pfad$ + "\"
END IF
DateiAng$ = UCASE$(DateiAng$)
Pfad$ = UCASE$(Pfad$)
Ebene = 1
Zeile = 3
' Fhre Aufruf mit oberster Ebene (Ebene 1) durch,
' um die Suche zu beginnen:
SuchVerz Pfad$, Ebene, DateiAng$, Zeile
KILL ROOT + ".*"   ' Lsche alle vom Programm
                     ' angelegten temporren Dateien.
LOCATE Zeile + 1, 1: PRINT "Suche beendet."
END

'
' ==================ERSTDATEINAM$=====================
'  Diese Prozedur erstellt einen Dateinamen aus
'  einer Basis-Zeichenkette
'  ("TWH", als symbolische Konstante auf Modul-
'  Ebene definiert) und einer an sie als Argument
'  bergebenen Zahl (Zahl).
'=====================================================
'
FUNCTION ErstDateiNam$ (Zahl) STATIC
   ErstDateiNam$ = ROOT + "." + LTRIM$(STR$(Zahl))
END FUNCTION

'
' ================== HOLEINTR ======================
'  Diese Prozedur verarbeitet Eintragszeilen einer
'  DIR-Liste, die in einer Datei gespeichert ist.
'
'  Diese Prozedur gibt die folgenden Werte aus:
'
'  HolEintr$   Ein gltiger Datei- oder
'              Verzeichnisname
'  EintrTyp    Wenn gleich 1, ist HolEintr$ eine
'              Datei
'              Wenn gleich 2, ist HolEintr$ ein
'              Verzeichnis.
'=====================================================
'
FUNCTION HolEintr$ (DateiZahl, EintrTyp) STATIC
   ' Wiederhole, bis ein gltiger Eintrag oder Ende der
   ' Datei (EOF) gelesen ist:

   DO UNTIL EOF(DateiZahl)
      LINE INPUT #DateiZahl, EintrZeile$
        IF EintrZeile$ <> "" THEN
        ' Hole erstes Zeichen von der Zeile zur
        ' berprfung:
        TestZeich$ = LEFT$(EintrZeile$, 1)
        IF TestZeich$ <> " " AND TestZeich$ <> "." THEN EXIT DO
      END IF
   LOOP

   ' Entscheide, ob Eintrag oder EOF gefunden:
   IF EOF(DateiZahl) THEN     ' EOF, also gib EOFTYP
      EintrTyp = EOFTYP       ' in EintrTyp zurck.
      HolEintr$ = ""
   ELSE     ' Nicht EOF, also mu es eine Datei oder
            ' ein Verzeichnis sein.
     'Erstelle den Namen des Eintrags und gib ihn aus:
      EintrName$ = RTRIM$(LEFT$(EintrZeile$, 8))
     'berprfe auf Erweiterung und fge diese dem
     'Namen hinzu, sofern eine vorhanden ist:
      EintrErw$ = RTRIM$(MID$(EintrZeile$, 10, 3))
      IF EintrErw$ <> "" THEN
         HolEintr$ = EintrName$ + "." + EintrErw$
      ELSE
         HolEintr$ = EintrName$
      END IF
      'Bestimme den Typ des Eintrags und gib diesen
      'Wert zurck an die Stelle, an der HolEintr$
      'aufgerufen wurde.
      IF MID$(EintrZeile$, 15, 3) = "DIR" THEN
         EintrTyp = DIRTYP            ' Verzeichnis
      ELSE
         EintrTyp = DATEITYP           ' Datei
      END IF
   END IF
END FUNCTION

'
' =================== SUCHVERZ =======================
'Diese Prozedur durchsucht rekursiv ein Verzeichnis
'nach dem Dateinamen, der vom Benutzer eingegeben
'wurde.
'
'BEACHTE: Der SUB-Kopf verwendet das Schlsselwort
'         STATIC nicht, da diese Prozedur bei jedem
'         Aufruf einen neuen Satz von Variablen
'         bentigt.
'=====================================================
'
SUB SuchVerz (Pfad$, Ebene, DateiAng$, Zeile)
   LOCATE 1, 1: PRINT "Ich durchsuche jetzt"; SPACE$(50);
   LOCATE 1, 22: PRINT Pfad$;
   ' Erstelle eine Dateibeschreibung fr die temporre
   ' Datei:
   TempBeschr$ = ErstDateiNam$(Ebene)
   ' Hole eine Verzeichnisliste des aktuellen
   ' Verzeichnisses und speichere sie in der
   ' temporren Datei:
   SHELL "DIR " + Pfad$ + " > " + TempBeschr$
   ' Hole die nchste verfgbare Dateinummer:
   DateiZahl = FREEFILE
   ' ffne die DIR-Listendatei und durchsuche sie:
   OPEN TempBeschr$ FOR INPUT AS #DateiZahl
   ' Verarbeite die Datei Zeile fr Zeile:
   DO
      'Lies den Eintrag aus der DIR-Listendatei ein:
      DirEintr$ = HolEintr$(DateiZahl, EintrTyp)
      ' Wenn Eintrag eine Datei ist:
      IF EintrTyp = DATEITYP THEN
      ' Wenn die Zeichenkette DateiAng$ passend ist,
      ' gibt den Eintrag aus und verlasse diese
      ' Schleife:
      IF DirEintr$ = DateiAng$ THEN
         LOCATE Zeile, 1: PRINT Pfad$; DirEintr$;
         Zeile = Zeile + 1
         EintrTyp = EOFTYP
      END IF
      ' Wenn der Eintrag ein Verzeichnis ist, fhre
      ' einen rekursiven Aufruf von SuchVerz mit dem
      ' neuen Verzeichnis durch:
      ELSEIF EintrTyp = DIRTYP THEN
         NeuPfad$ = Pfad$ + DirEintr$ + "\"
         SuchVerz NeuPfad$, Ebene + 1, DateiAng$, Zeile
         LOCATE 1, 1: PRINT "Ich durchsuche jetzt"; SPACE$(50);
         LOCATE 1, 22: PRINT Pfad$;
      END IF
   LOOP UNTIL EintrTyp = EOFTYP
   ' Die Durchsuchung dieser Datei ist beendet, also
   ' schliee sie:
   CLOSE DateiZahl
END SUB

