DEFINT A-Z         'Standardvariablentyp ist Ganzzahl.
' Die FUNCTION Sicherung$ erstellt eine Sicherungsdatei
' mit dem Basisnamen der zu verndernden Datei und der
' Namenserweiterung.BAK:
DECLARE FUNCTION Sicherung$ (DateiName$)
' Initialisiere symbolische Konstanten und Variablen:
CONST FALSCH = 0, WAHR = NOT FALSCH
DruRueck$ = CHR$(13)
ZeilenVor$ = CHR$(10)
DO
   CLS
   ' Eingabe des Namens der zu verndernden Datei:
   INPUT "Welche Datei wollen Sie bertragen"; AusDatei$
   InDatei$ = Sicherung$(AusDatei$) ' Hole den Namen
				    ' der
				    ' Sicherungsdatei.
   ON ERROR GOTO FehlerBehand  ' Schalte
			       ' Fehlerverfolgung ein.
   NAME AusDatei$ AS InDatei$  ' Kopiere die
			       ' Eingabedatei in die
			       ' Sicherungsdatei.
   ON ERROR GOTO 0             ' Schalte die
			       ' Fehlerverfolgung aus.
   ' ffne die Sicherungsdatei fr Eingabe und die
   ' alte Datei fr Ausgabe:
   OPEN InDatei$ FOR INPUT AS #1
   OPEN AusDatei$ FOR OUTPUT AS #2
   ' Die Variable VorDruRueck ist eine Flagge, die
   ' immer dann auf wahr gesetzt wird, wenn das
   ' Programm ein Wagenrcklaufzeichen liest:
   VorDruRueck = FALSCH
   ' Lies aus der Eingabedatei bis das Dateiende
   ' erreicht ist:
   DO UNTIL EOF(1)
      ' Dies ist nicht das Ende der Datei, lies
      ' deshalb ein Zeichen:
      DateiZeich$ = INPUT$(1, #1)
      SELECT CASE DateiZeich$
	  CASE DruRueck$     ' Das Zeichen ist ein CR.
	     ' Wenn das vorhergehende Zeichen
	     ' ebenfalls ein CR war, schreibe ein LF
	     ' vor das Zeichen:
	     IF VorDruRueck THEN
		DateiZeich$ = ZeilenVor$ + DateiZeich$
	     END IF
	     ' Setze in jedem Fall die Variable
	     ' VorDruRueck auf WAHR:
	     VorDruRueck = WAHR
	 CASE ZeilenVor$     ' Das Zeichen ist ein LF.
	    ' Wenn das vorhergehende Zeichen kein CR
	    ' war, schreibe ein CR vor das Zeichen:
	    IF NOT VorDruRueck THEN
	       DateiZeich$ = DruRueck$ + DateiZeich$
	   END IF
	   ' Setze die Variable VorDruRueck in jedem
	   ' Fall auf FALSCH:
	   VorDruRueck = FALSCH
	 CASE ELSE         ' Weder ein CR noch ein LF.
	    ' Wenn das vorhergehende Zeichen ein CR
	    ' war, dann setze die Variable VorDruRueck
	    ' auf FALSCH und schreibe ein LF vor das
	    ' aktuelle Zeichen:
	   IF VorDruRueck THEN
	      VorDruRueck = FALSCH
	      DateiZeich$ = ZeilenVor$ + DateiZeich$
	   END IF
      END SELECT
      ' Schreibe das/die Zeichen in die neue Datei:
      PRINT #2, DateiZeich$;
   LOOP
   ' Schreibe ein LF, wenn das letzte Zeichen der
   ' Datei ein CR war:
   IF VorDruRueck THEN PRINT #2, ZeilenVor$;
   CLOSE                     ' Schliee beide Dateien.
   PRINT "Eine weitere Datei (J/N)?"  ' Anfrage zum
				      ' Fortfhren.
   ' Verndere die Eingabe in Grobuchstaben:
   Weiter$ = UCASE$(INPUT$(1))
' Setze das Programm fort, wenn der Benutzer ein "j"
' oder "J" eingegeben hat:
LOOP WHILE Weiter$ = "J"
END
FehlerBehand:          ' Fehlerbehandlungsroutine
   CONST KEINEDATEI = 53, DATEIDA = 58
   ' Die Funktion ERR gibt den Fehlercode des letzten
   ' Fehlers an:
   SELECT CASE ERR
      CASE KEINEDATEI  ' Programm konnte Datei mit dem
		       ' eingegebenen Namen nicht
		       ' finden.
	 PRINT "Keine solche Datei im aktuellen "
	 PRINT "Verzeichnis vorhanden."
	 INPUT "Geben Sie neuen Namen ein: ", AusDatei$
	 InDatei$ = Sicherung$(AusDatei$)
	 RESUME
      CASE DATEIDA     ' Der Dateiname <Dateiname>
		       ' existiert bereits in diesem
		       ' Verzeichnis: entferne die
		       ' Datei und fahre dann fort.
	 KILL InDatei$
	 RESUME
      CASE ELSE        ' Ein unerwarteter Fehler trat
		       ' auf: beende das Programm.
	 ON ERROR GOTO 0
   END SELECT

'
' =================== SICHERUNG$ =====================
'   Diese Prozedur gibt einen Dateinamen an, der aus
'   dem Basisnamen der eingegebenen Datei (alles vor
'   dem ".") plus der Erweiterung ".BAK" besteht.
' ======================================================
'
FUNCTION Sicherung$ (DateiName$) STATIC
   ' Suche nach einem Punkt:
   Erweiterung = INSTR(DateiName$, ".")
   ' Wenn ein Punkt vorhanden ist, fge .BAK zu der
   ' Basis hinzu:
   IF Erweiterung > 0 THEN
      Sicherung$ = LEFT$(DateiName$, Erweiterung - 1) + ".BAK"
   ' Andernfalls fge dem ganzen Namen .BAK hinzu:
   ELSE
      Sicherung$ = DateiName$ + ".BAK"
   END IF
END FUNCTION

