DEFINT A-Z
'
'   Microsoft EntfZeil - Hilfsprogramm zum Entfernen von Zeilennummern
'   Copyright (C) Microsoft Corporation   - 1985, 1986, 1987
'
'   ENTFZEIL.BAS ist ein Programm, das aus Microsoft BASIC-Programmen
'   Zeilennummern entfernt. Es entfernt nur solche Zeilennummern, die
'   sich nicht auf eine der folgenden Anweisungen beziehen: GOSUB,
'   RETURN, GOTO, THEN, ELSE, RESUME, RESTORE oder RUN.
'
'   ENTFZEIL wird mit der folgenden Eingabe gestartet
'
'      ENTFZEIL [<Eingabe> [, <Ausgabe>]]
'
'   wobei <Eingabe> der Name der zu verarbeitenden Datei und <Ausgabe> der
'   Name der Datei bzw. des Gertes ist, die bzw. das die umformatierte
'   Ausgabe empfngt. Wenn keine Erweiterung angegeben ist, wird .BAS
'   angenommen (auer fr Ausgabegerte). Falls keine Dateinamen angege-
'   ben sind, fragt ENTFZEIL Sie nach den Dateinamen. Wenn beide Dateinamen
'   identisch sind, speichert ENTFZEIL die Originaldatei mit der Erweiterung
'   .BAK.
'
'   ENTFZEIL geht bezglich des Programmes von mehreren Voraussetzungen aus:
'
'     1. Es mu syntaktisch korrekt sein und mu im BASICA- oder
'        GWBASIC-Interpreter laufen.
'     2. Die Obergrenze ist 400 Zeilen. Um grere Dateien zu verar-
'        beiten, mssen Sie die Konstante MaxZeilen ndern.
'     3. Die erste auf einer Zeile gefundene Zahl wird als Zeilennummer
'        betrachtet; daher knnten einige Fortsetzungszeilen (in einer
'        compilerspezifischen Konstruktion) unkorrekt bearbeitet werden.
'     4. ENTFZEIL sollte nicht fr Programme eingesetzt werden, die von
'        ERL abhngen, da ERL die Existenz von Zeilennummern voraussetzt.
'
'   Wenn Sie die Art und Weise, in der ENTFZEIL seine Ausgabe formatiert,
'   nicht mgen, knnen Sie die Ausgabezeilen in SUB ErzAusgDat verndern.
'   Ein Beispiel ist in den Kommentaren gezeigt.

' Deklarationen der Funktionen und Unterprogramme

DECLARE FUNCTION ErmGrundSym$ (Such$, Begrenz$)
DECLARE FUNCTION StrSpn% (InZeichKett$, Trenner$)
DECLARE FUNCTION StrBrk% (InZeichKett$, Trenner$)
DECLARE FUNCTION IstZahl% (Zeich$)
DECLARE SUB LiesDatNamen ()
DECLARE SUB BildeTabelle ()
DECLARE SUB ErzAusgDat ()
DECLARE SUB InitSchlWoTab ()

' Globale und konstante Daten

CONST WAHR = -1
CONST falsch = 0
CONST MaxZeilen = 400

DIM SHARED ZeilenTab!(MaxZeilen)
DIM SHARED ZeilenZaehl
DIM SHARED Trenn$, EingDatei$, AusgDatei$, TmpDatei$

' Daten fr die Suche der Schlsselworte

CONST SchlWortZaehl = 8
DIM SHARED SchlWortTab$(SchlWortZaehl)

SchlWortData:
   DATA THEN, ELSE, GOSUB, GOTO, RESUME, RETURN, RESTORE, RUN

' Anfang des Modul-Ebenen-Programmcodes

   Trenn$ = " ,:" + CHR$(9)
   InitSchlWoTab
   LiesDatNamen
   ON ERROR GOTO DatFehl1
   OPEN EingDatei$ FOR INPUT AS 1
   ON ERROR GOTO 0
   COLOR 7: PRINT "Verarbeitung luft"; : COLOR 23: PRINT " . . ."
   COLOR 7: PRINT
   BildeTabelle
   CLOSE #1
   OPEN EingDatei$ FOR INPUT AS 1
   ON ERROR GOTO DatFehl2
   OPEN AusgDatei$ FOR OUTPUT AS 2
   ON ERROR GOTO 0
   ErzAusgDat
   CLOSE #1, #2
   IF AusgDatei$ <> "CON" THEN CLS

END

DatFehl1:
   CLS
   PRINT "      Ungltiger Dateiname": PRINT
   INPUT "      Neue Eingabe des Namens (EINGABETASTE beendet): ", EingDatei$
   IF EingDatei$ = "" THEN END
DatFehl2:
   INPUT "      Name der Ausgabedatei (EINGABETASTE bestimmt Bildschirm) :", AusgDatei$
   PRINT
   IF (AusgDatei$ = "") THEN AusgDatei$ = "CON"
   IF TmpDatei$ = "" THEN
      RESUME
   ELSE
      TmpDatei$ = ""
      RESUME NEXT
   END IF

'
' BildeTabelle:
'   Untersucht die gesamte Textdatei, wobei nach Zeilennummern gesucht wird,
'   die in einem Zusammenhang mit GOTO, GOSUB etc. stehen. Sobald eine
'   solche Nummer gefunden ist, wird sie in einer Tabelle mit Zeilennummern
'   abgelegt. Diese Tabelle wird whrend eines zweiten Schrittes verwendet
'   (siehe ErzAusgDat), wenn alle Zeilennummern, die sich nicht in der Liste
'   befinden, entfernt werden.
' Eingabe:
'   Verwendet die globalen Variablen SchlWortTab$, SchlWortZaehl und Trenn$
' Ausgabe:
'   Verndert ZeilenTab! und ZeilenZaehl
'
SUB BildeTabelle STATIC

   DO WHILE NOT EOF(1)
      ' Lies Zeile und erstes Grundsymbol (Token)
      LINE INPUT #1, EinZei$
      GrundSym$ = ErmGrundSym$(EinZei$, Trenn$)
      DO WHILE (GrundSym$ <> "")
         FOR SchlIndex = 1 TO SchlWortZaehl
            ' berprfe, ob Grundsymbol Schlsselwort ist
            IF (SchlWortTab$(SchlIndex) = UCASE$(GrundSym$)) THEN
               ' Lies mgliche Zeilennummer nach Schlsselwort
               GrundSym$ = ErmGrundSym$("", Trenn$)
               ' berprfe jedes Grundsymbol darufhin, ob es eine Zeilennummer
               ' ist (die SCHLEIFE ist notwendig, da ein ON GOSUB oder ON GOTO
               ' mehrere Nummern haben kann). Ein nicht-numerisches Grund-
               'symbol beendet die Suche.
               DO WHILE (IstZahl(LEFT$(GrundSym$, 1)))
                  ZeilenZaehl = ZeilenZaehl + 1
                  ZeilenTab!(ZeilenZaehl) = VAL(GrundSym$)
                  GrundSym$ = ErmGrundSym$("", Trenn$)
                  IF GrundSym$ <> "" THEN SchlIndex = 0
               LOOP
            END IF
         NEXT SchlIndex
         ' Lies nchstes Grundsymbol (Token)
         GrundSym$ = ErmGrundSym$("", Trenn$)
      LOOP
   LOOP

END SUB

'
' ErmGrundSym$:
'  Entnimmt Grundsymbole (Tokens) aus einer Zeichenkette. Ein Grundsymbol
'  ist ein Wort, das von Trennzeichen, wie zum Beispiel Leerzeichen oder
'  Kommata, umgeben ist. Grundsymbole werden entnommen und analysiert, wenn
'  Stze oder Befehle zerlegt werden. Um die Funktion ErmGrundSym$ zu
'  verwenden, bergeben Sie die zu zerlegende Zeichenkette im ersten Aufruf
'  und bergeben anschlieend bei nachfolgenden Aufrufen solange eine
'  Nullzeichenkette, bis die Funktion eine Null zurckgibt, um anzuzeigen,
'  da die gesamte Zeichenkette zerlegt ist.
' Eingabe:
'  Such$ = zu durchsuchende Zeichenkette
'  Begrenz$  = Kette von Trennzeichen
' Ausgabe:
'  ErmGrundSym$ = nchstes Grundsymbol
'
FUNCTION ErmGrundSym$ (Such$, Begrenz$) STATIC

   ' Beachten Sie, da SichZKett$ und AnfPos von Aufruf zu Aufruf unverndert
   ' (static) bleiben mssen (andere Variablen sind nur wegen der
   ' Ausfhrungsgeschwindigkeit statisch).
   ' Falls erster Aufruf, mache eine Kopie der Zeichenkette
   IF (Such$ <> "") THEN
      AnfPos = 1
      SichZKett$ = Such$
   END IF
 
   ' Suche den Anfang des nchsten Grundsymbols
   NeuPos = StrSpn(MID$(SichZKett$, AnfPos, LEN(SichZKett$)), Begrenz$)
   IF NeuPos THEN
      ' Setze Position auf Anfang des Grundsymbols
      AnfPos = NeuPos + AnfPos - 1
   ELSE
      ' Wenn kein neues Grundsymbol, verlasse und gib Null zurck
      ErmGrundSym$ = ""
      EXIT FUNCTION
   END IF

   ' Suche Ende des Grundsymbols
   NeuPos = StrBrk(MID$(SichZKett$, AnfPos, LEN(SichZKett$)), Begrenz$)
   IF NeuPos THEN
      ' Setze Position auf Ende des Grundsymbols
      NeuPos = AnfPos + NeuPos - 1
   ELSE
      ' Kein Ende des Grundsymbols
      NeuPos = LEN(SichZKett$) + 1
   END IF
   ' Schneide Grundsymbol aus der zu durchsuchenden Zeichenkette
   ErmGrundSym$ = MID$(SichZKett$, AnfPos, NeuPos - AnfPos)
   ' Setze neue Anfangsposition
   AnfPos = NeuPos

END FUNCTION

'
' ErzAusgDat:
'  Erzeugt eine Ausgabedatei, in der Zeilennummern, auf die kein Bezug
'  genommen wird, entfernt sind.
' Eingabe:
'  Verwendet die globalen Variablen ZeilenTab!, ZeilenZaehl und Trenn$
' Ausgabe:
'  Verarbeitete Datei
'
SUB ErzAusgDat STATIC

   ' Beschleunige, indem Komma und Semikolon eliminiert werden (kann erstes
   ' Grundsymbol nicht abtrennen)
   Tren$ = " " + CHR$(9)
   DO WHILE NOT EOF(1)
      LINE INPUT #1, EinZei$
      IF (EinZei$ <> "") THEN
         ' Lies erstes Grundsymbol und verarbeite es, wenn es sich um eine
         ' Zeilennummer handelt
         GrundSym$ = ErmGrundSym$(EinZei$, Tren$)
         IF IstZahl(LEFT$(GrundSym$, 1)) THEN
            ZeilNummer! = VAL(GrundSym$)
            NummerGef = falsch
            ' berprfe, ob Zeilennummer sich in der Tabelle mit den
            ' Zeilennummern befindet, auf die Bezug genommen wird
            FOR index = 1 TO ZeilenZaehl
               IF (ZeilNummer! = ZeilenTab!(index)) THEN
                  NummerGef = WAHR
               END IF
            NEXT index
            ' Verndere Zeichenketten einer Zeile
            IF (NOT NummerGef) THEN
               GrundSym$ = SPACE$(LEN(GrundSym$))
               MID$(EinZei$, StrSpn(EinZei$, Tren$), LEN(GrundSym$)) = GrundSym$
            END IF
             
            ' Die vorhergehenden Zeilen knnen Sie durch eigenen Code
            ' ersetzen, um die Ausgabe umzuformatieren. Versuchen Sie zum
            ' Beispiel die folgenden Zeilen:
              
            'TmpPos1 = StrSpn(EinZei$, Tren$) + LEN(GrundSym$)
            'TmpPos2 = TmpPos1 + StrSpn(MID$(EinZei$, TmpPos1), Tren$)
            '
            'IF NummerGef THEN
            '   EinZei$ = LEFT$(EinZei$, TmpPos1 - 1) + CHR$(9) + MID$(EinZei$, TmpPos2)
            'ELSE
            '   EinZei$ = CHR$(9) + MID$(EinZei$, TmpPos2)
            'END IF

         END IF
      END IF
      ' Gib Zeile auf Datei oder Konsole aus (PRINT ist schneller als die
      ' Konsole)
      IF AusgDatei$ = "CON" THEN
         PRINT EinZei$
      ELSE
         PRINT #2, EinZei$
      END IF
   LOOP

END SUB

'
' InitSchlWoTab:
'  Initialisiert eine Tabelle mit Schlsselworten. Die Schlsselworte
'  mssen erkannt werden, so da Zeilennummern von numerischen Konstanten
'  unterschieden werden knnen.
' Eingabe:
'  Verwendet SchlWortData
' Ausgabe:
'  Verndert das globale Datenfeld SchlWortTab$
'
SUB InitSchlWoTab STATIC

   RESTORE SchlWortData
   FOR Zaehl = 1 TO SchlWortZaehl
      READ SchlWort$
      SchlWortTab$(Zaehl) = SchlWort$
   NEXT

END SUB

'
' IstZahl:
'  Gibt wahr zurck, wenn das bergebene Zeichen eine Dezimalzahl ist. Da
'  jedes BASIC-Grundsymbol, das mit einer Ziffer beginnt, eine Zahl ist,
'  mu die Funktion nur die erste Ziffer berprfen. Es wird nicht auf
'  negative Zahlen geprft, das ist hier aber auch nicht notwendig.
' Eingabe:
'  Zeich$ - Anfangszeichen der zu berprfenden Zeichenkette
' Ausgabe:
'  IstZahl - wahr, wenn innerhalb 0 - 9
'
FUNCTION IstZahl (Zeich$) STATIC

   IF (Zeich$ = "") THEN
      IstZahl = falsch
   ELSE
      ZeichAsc = ASC(Zeich$)
      IstZahl = (ZeichAsc >= ASC("0")) AND (ZeichAsc <= ASC("9"))
   END IF

END FUNCTION

'
' LiesDatNamen:
'  Liest einen Dateinamen aus COMMAND$ oder nach einer Aufforderung
'  an den Benutzer.
' Eingabe:
'  Verwendet Command$ oder Benutzereingabe
' Ausgabe:
'  Definiert EingDatei$ und AusgDatei$
'
SUB LiesDatNamen STATIC

   IF (COMMAND$ = "") THEN
      CLS
      PRINT " Microsoft EntfZeil: Hilfsprogramm zum Entfernen von Zeilennummern"
      PRINT "    (ohne Angabe einer Erweiterung wird .BAS angenommen)"
      PRINT
      INPUT "    Name der Eingabedatei (EINGABE beendet): ", EingDatei$
      IF EingDatei$ = "" THEN END
      INPUT "    Name der Ausgabedatei (EINGABE bestimmt Bildschirm) :", AusgDatei$
      PRINT
      IF (AusgDatei$ = "") THEN AusgDatei$ = "CON"
   ELSE
      EingDatei$ = UCASE$(ErmGrundSym$(COMMAND$, Trenn$))
      AusgDatei$ = UCASE$(ErmGrundSym$("", Trenn$))
      IF (AusgDatei$ = "") THEN
         INPUT "    Name der Ausgabedatei (EINGABE bestimmt Bildschirm) :", AusgDatei$
         PRINT
         IF (AusgDatei$ = "") THEN AusgDatei$ = "CON"
      END IF
   END IF
   IF INSTR(EingDatei$, ".") = 0 THEN
      EingDatei$ = EingDatei$ + ".BAS"
   END IF
   IF INSTR(AusgDatei$, ".") = 0 THEN
      SELECT CASE AusgDatei$
         CASE "CON", "SCRN", "PRN", "COM1", "COM2", "LPT1", "LPT2", "LPT3"
            EXIT SUB
         CASE ELSE
            AusgDatei$ = AusgDatei$ + ".BAS"
      END SELECT
   END IF
   DO WHILE EingDatei$ = AusgDatei$
      TmpDatei$ = LEFT$(EingDatei$, INSTR(EingDatei$, ".")) + "BAK"
      ON ERROR GOTO DatFehl1
      NAME EingDatei$ AS TmpDatei$
      ON ERROR GOTO 0
      IF TmpDatei$ <> "" THEN EingDatei$ = TmpDatei$
   LOOP

END SUB

'
' StrBrk:
'  Durchsucht InZeichKett$, um das erste Zeichen zu finden, das einem
'  derjenigen in Trenner$ entspricht. Gibt den Index dieses Zeichens
'  zurck. Diese Funktion kann dazu verwendet werden, das Ende eines
'  Grundsymbols zu finden.
' Eingabe:
'  InZeichKett$ = zu durchsuchende Zeichenkette
'  Trenner$ = Zeichen, nach denen gesucht wird
' Ausgabe:
'  StrBrk = Index der ersten bereinstimmung in InZeichKett$ bzw. 0, wenn
'  keine bereinstimmung
'
FUNCTION StrBrk (InZeichKett$, Trenner$) STATIC

   Ln = LEN(InZeichKett$)
   AnfPos = 1
   ' berprfe auf Ende des Grundsymbols (erstes Zeichen, das ein
   ' Begrenzer ist).
   DO WHILE INSTR(Trenner$, MID$(InZeichKett$, AnfPos, 1)) = 0
      IF AnfPos > Ln THEN
         StrBrk = 0
         EXIT FUNCTION
      ELSE
         AnfPos = AnfPos + 1
      END IF
   LOOP
   StrBrk = AnfPos
 
END FUNCTION

'
' StrSpn:
'  Durchsucht InZeichKett$, um das erste Zeichen zu finden, das nicht
'  einem derjenigen in Trenner$ entspricht. Gibt den Index dieses Zeichens
'  zurck. Diese Funktion kann dazu verwendet werden, den Anfang eines
'  Grundsymbols zu suchen.
' Eingabe:
'  InZeichKett$ = zu durchsuchende Zeichenkette
'  Trenner$ = Zeichen, nach denen gesucht wird
' Ausgabe:
'  StrSpn = Index der ersten Nichtbereinstimmung in InZeichKett$ oder 0,
'  wenn alle Zeichen bereinstimmen
'
FUNCTION StrSpn% (InZeichKett$, Trenner$) STATIC

   Ln = LEN(InZeichKett$)
   AnfPos = 1
   ' berprfe auf Anfang eines Grundsymbols (Zeichen, das kein
   ' Begrenzer ist).
   DO WHILE INSTR(Trenner$, MID$(InZeichKett$, AnfPos, 1))
      IF AnfPos > Ln THEN
         StrSpn = 0
         EXIT FUNCTION
      ELSE
         AnfPos = AnfPos + 1
      END IF
   LOOP
   StrSpn = AnfPos

END FUNCTION

